Imports System.IO
Imports System.IO.File
Imports System.Runtime.InteropServices

Public Class Form1

    Private Const NUM_VALUES As Integer = 10
    Const INTEGER_SIZE As Integer = 4

    Private m_TextBoxes() As TextBox

    ' Load saved values.
    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        m_TextBoxes = New TextBox() {TextBox1, TextBox2, TextBox3, TextBox4, TextBox5, TextBox6, TextBox7, TextBox8, TextBox9, TextBox10}

        ' Get the file name.
        Dim file_name As String = GetFileName()

        ' See if the file exists.
        If Exists(file_name) Then
            ' Open the file.
            Dim fs As New FileStream(file_name, FileMode.Open)

            ' Create a BinaryReader for the FileStream.
            Dim binary_reader As New BinaryReader(fs)
            fs.Position = 0

            ' Read the data as a byte array.
            Dim bytes() As Byte = binary_reader.ReadBytes(fs.Length)

            ' Copy the bytes into an integer array.
            Dim integers() As Integer = BytesToIntegers(bytes)
            binary_reader.Close()
            fs.Dispose()

            ' Display values.
            For i As Integer = 0 To NUM_VALUES - 1
                m_TextBoxes(i).Text = integers(i).ToString()
            Next i
        End If
    End Sub

    ' Save the current values.
    Private Sub Form1_FormClosing(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing
        ' Get the file name.
        Dim file_name As String = GetFileName()

        ' Create the file.
        Using fs As New FileStream(file_name, FileMode.Create)
            ' Create a BinaryWriter for the FileStream.
            Dim binary_writer As New BinaryWriter(fs)

            ' Get the values.
            Dim integers(NUM_VALUES - 1) As Integer
            For i As Integer = 0 To NUM_VALUES - 1
                integers(i) = Val(m_TextBoxes(i).Text)
            Next i

            ' Copy the integers into a byte array.
            Dim bytes() As Byte = IntegersToBytes(integers)

            ' Write the bytes into the file.
            binary_writer.Write(bytes)

            binary_writer.Close()
        End Using
    End Sub

    Private Function IntegersToBytes(ByVal integers() As Integer) As Byte()
        ' Allocate the bytes array.
        Dim bytes(integers.Length * INTEGER_SIZE - 1) As Byte

        ' Pin the bytes array.
        Dim gc_handle As GCHandle = GCHandle.Alloc(bytes, GCHandleType.Pinned)

        ' Copy the integers.
        System.Runtime.InteropServices.Marshal.Copy( _
            integers, 0, gc_handle.AddrOfPinnedObject, _
            integers.Length)

        ' Unpin the bytes array.
        gc_handle.Free()

        ' Return the result.
        Return bytes
    End Function

    Private Function BytesToIntegers(ByVal bytes() As Byte) As Integer()
        ' Allocate the integers array.
        Dim integers(bytes.Length \ INTEGER_SIZE - 1) As Integer

        ' Pin the integers array.
        Dim gc_handle As GCHandle = GCHandle.Alloc(integers, GCHandleType.Pinned)

        ' Copy the bytes.
        System.Runtime.InteropServices.Marshal.Copy( _
            bytes, 0, gc_handle.AddrOfPinnedObject, _
            bytes.Length)

        ' Unpin the integers array.
        gc_handle.Free()

        ' Return the result.
        Return integers
    End Function

    Private Function GetFileName() As String
        Dim file_name As String = Application.StartupPath
        If file_name.EndsWith("\bin\Debug") Then file_name = file_name.Substring(0, file_name.Length - 10)
        If Not file_name.EndsWith("\") Then file_name &= "\"
        Return file_name & "numbers.dat"
    End Function
End Class
